//---------------------------------------------------------------------------

#ifndef TFormMainH
#define TFormMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "CPort.hpp"
#include "te_controls.hpp"
#include "TntComCtrls.hpp"
#include "TntStdCtrls.hpp"
#include <ComCtrls.hpp>
#include "Protocol.h"
#include "TFormMessage.h"
#include "TFormComPort.h"
#include <IdAntiFreeze.hpp>
#include <IdAntiFreezeBase.hpp>
#include <IdBaseComponent.hpp>
#include <IdComponent.hpp>
#include <IdDNSResolver.hpp>
#include <IdIcmpClient.hpp>
#include <IdRawBase.hpp>
#include <IdRawClient.hpp>
#include <IdUDPBase.hpp>
#include <IdUDPClient.hpp>
#include <ScktComp.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "TntButtons.hpp"
#include "TntExtCtrls.hpp"
#include <Buttons.hpp>
#include <IdUDPServer.hpp>
//---------------------------------------------------------------------------
class TFormMain : public TForm
{
__published:	// IDE-managed Components
        TTeButton *BitBtnExit;
        TComPort *ComPort1;
        TIdDNSResolver *IdDNSResolver;
        TIdIcmpClient *IdIcmpClient1;
        TClientSocket *ClientSocket1;
        TIdAntiFreeze *IdAntiFreeze1;
        TTntPageControl *pcMessage;
        TTntTabSheet *tsEnv;
        TTntLabel *Label1;
        TTntLabel *Label2;
        TTntLabel *Label3;
        TTntLabel *Label4;
        TTntLabel *Label5;
        TTntLabel *Label6;
        TTntLabel *Label7;
        TTntLabel *Label8;
        TTntLabel *Label9;
        TTntLabel *Label10;
        TTntLabel *Label11;
        TTntLabel *Label12;
        TTntLabel *Label14;
        TTntLabel *Label16;
        TTntLabel *Label17;
        TTntLabel *Label18;
        TTntLabel *Label23;
        TTntLabel *Label24;
        TTntLabel *Label13;
        TTntLabel *Label15;
        TTntLabel *Label19;
        TTeComboBox *cbPageNo;
        TTeGroupBox *rbTextNo;
        TTeRadioButton *rbNo1;
        TTeRadioButton *rbNo2;
        TTeRadioButton *rbNo3;
        TTeComboBox *cbStartYPos;
        TTeComboBox *cbStartXPos;
        TTeComboBox *cbSpeed;
        TTeComboBox *cbLasEffect;
        TTeComboBox *cbLasDirect;
        TTeComboBox *cbFontSize;
        TTeComboBox *cbEntEffect;
        TTeComboBox *cbEntDirect;
        TTeComboBox *cbEndYPos;
        TTeComboBox *cbEndXPos;
        TTeComboBox *cbDispType;
        TTeComboBox *cbDispControl;
        TTeComboBox *cbDelay;
        TTeComboBox *cbCodeKind;
        TTeComboBox *cbBGImage;
        TTeComboBox *cbAssistEffect;
        TTntEdit *eColor;
        TTntEdit *eBGColor;
        TTntCheckBox *cbRevRefeat;
        TTntRichEdit *eData;
        TTntTabSheet *tsNomarl;
        TTntLabel *TeLabel9;
        TTntLabel *TeLabel8;
        TTntLabel *TeLabel7;
        TTntLabel *TeLabel6;
        TTntLabel *TeLabel5;
        TTntLabel *TeLabel4;
        TTntLabel *TeLabel3;
        TTntLabel *TeLabel20;
        TTntLabel *TeLabel19;
        TTntLabel *TeLabel2;
        TTntLabel *TeLabel21;
        TTntLabel *TeLabel18;
        TTntLabel *TeLabel17;
        TTntLabel *TeLabel16;
        TTntLabel *TeLabel15;
        TTntLabel *TeLabel14;
        TTntLabel *TeLabel13;
        TTntLabel *TeLabel12;
        TTntLabel *TeLabel11;
        TTntLabel *TeLabel10;
        TTntLabel *TeLabel1;
        TTeGroupBox *rbTextNo2;
        TTeRadioButton *rbNo21;
        TTeRadioButton *rbNo22;
        TTeRadioButton *rbNo23;
        TTeComboBox *cbStartYPos2;
        TTeComboBox *cbStartXPos2;
        TTeComboBox *cbSpeed2;
        TTeComboBox *cbPageNo2;
        TTeComboBox *cbLasEffect2;
        TTeComboBox *cbLasDirect2;
        TTeComboBox *cbFontSize2;
        TTeComboBox *cbEntEffect2;
        TTeComboBox *cbEntDirect2;
        TTeComboBox *cbEndYPos2;
        TTeComboBox *cbEndXPos2;
        TTeComboBox *cbDispType2;
        TTeComboBox *cbDispControl2;
        TTeComboBox *cbDelay2;
        TTeComboBox *cbCodeKind2;
        TTeComboBox *cbBGImage2;
        TTeComboBox *cbAssistEffect2;
        TTntEdit *eColor2;
        TTntEdit *eBGColor2;
        TTntRichEdit *eData2;
        TTntTabSheet *tsETC;
        TLabel *Label25;
        TTeGroupBox *gbMemClear;
        TTeButton *BMemClear;
        TTeComboBox *cbMsgMemClear;
        TTeGroupBox *gbMemInput;
        TTeButton *BInput;
        TTeComboBox *cbMsgInput;
        TTeGroupBox *gbBGImage;
        TTeButton *BBGImage;
        TTeComboBox *cbBGISelect;
        TTeGroupBox *gbSync;
        TTeLabel *SLabel1;
        TTeLabel *SLabel2;
        TTeLabel *TeLabel22;
        TTeLabel *TeLabel23;
        TTeComboBox *cbSoundSec1;
        TTeComboBox *cbSoundSec2;
        TTeButton *SendSync;
        TTeButton *BitBtnPowerLEDOn;
        TTeButton *BitBtnPowerLEDOff;
        TTeButton *BitBtnSyncLED;
        TTeButton *BDIBDTime;
        TTeButton *DataSend;
        TPanel *Panel7;
        TRichEdit *RichEditLog;
        TTntPanel *pnLog;
        TTePanel *pnLogButton;
        TTeSpeedButton *sbLogClear;
        TTePanel *ToolbarMain;
        TTeSpeedButton *NComPort;
        TIdUDPClient *IdUDPClient;
        TIdUDPServer *IdUDPServer;
        TTntGroupBox *gbSignSize;
        TTntLabel *TntLabel1;
        TTntLabel *TntLabel3;
        TTntLabel *TntLabel2;
        TTntLabel *TntLabel5;
        TTntLabel *TntLabel6;
        TTntEdit *TntEdit1;
        TTntUpDown *UpDownHeight;
        TTntEdit *TntEdit2;
        TTntUpDown *UpDownWidth;
        TTntComboBox *cbProgramType;
        TTeButton *BtnSignSize;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall BitBtnExitClick(TObject *Sender);
        void __fastcall ComPort1RxChar(TObject *Sender, int Count);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall IdIcmpClient1Reply(TComponent *ASender,
          const TReplyStatus &AReplyStatus);
        void __fastcall ClientSocket1Connect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ClientSocket1Disconnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ClientSocket1Error(TObject *Sender,
          TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
          int &ErrorCode);
        void __fastcall ClientSocket1Read(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall BitBtnSyncLEDClick(TObject *Sender);
        void __fastcall IdUDPClientStatus(TObject *ASender,
          const TIdStatus AStatus, const AnsiString AStatusText);
        void __fastcall IdUDPServerStatus(TObject *ASender,
          const TIdStatus AStatus, const AnsiString AStatusText);
        void __fastcall IdUDPServerUDPRead(TObject *Sender, TStream *AData,
          TIdSocketHandle *ABinding);
        void __fastcall cbEntEffectClick(TObject *Sender);
        void __fastcall cbEntEffectDropDown(TObject *Sender);
        void __fastcall cbEntDirectDropDown(TObject *Sender);
        void __fastcall cbLasEffectClick(TObject *Sender);
        void __fastcall cbLasEffectDropDown(TObject *Sender);
        void __fastcall cbLasDirectDropDown(TObject *Sender);
        void __fastcall cbEntEffect2Click(TObject *Sender);
        void __fastcall cbEntEffect2DropDown(TObject *Sender);
        void __fastcall cbEntDirect2DropDown(TObject *Sender);
        void __fastcall cbLasEffect2Click(TObject *Sender);
        void __fastcall cbLasEffect2DropDown(TObject *Sender);
        void __fastcall cbLasDirect2DropDown(TObject *Sender);
        void __fastcall rbTextNoClick(TObject *Sender);
        void __fastcall rbTextNo2Click(TObject *Sender);
        void __fastcall cbFontSizeClick(TObject *Sender);
        void __fastcall cbFontSize2Click(TObject *Sender);
        void __fastcall rbTextNoRoadClick(TObject *Sender);
        void __fastcall rbTextNoRoad2Click(TObject *Sender);
        void __fastcall BMemClearClick(TObject *Sender);
        void __fastcall SendSyncClick(TObject *Sender);
        void __fastcall tsShow(TObject *Sender);
        void __fastcall BitBtnPowerLEDClick(TObject *Sender);
        void __fastcall DataSendClick(TObject *Sender);
        void __fastcall BtnSignSizeClick(TObject *Sender);
        void __fastcall NComPortClick(TObject *Sender);
        void __fastcall BDIBDTimeClick(TObject *Sender);
        void __fastcall sbLogClearClick(TObject *Sender);
private:	// User declarations
        TFormMessage *FMessage; //޽ 
        TFormComPort *FComPort; // ż 
        int WaitTime;   //ú   ð
        int DelayTime;  //ú    ð
        int ServerCommOpenDelay; // TCP/IP ý   ȵɶ  ð
        bool SchBmpFile; // ú  Ȯ ÷
        bool DelayRun; // ú   ð ÷
        bool bCRCFail; // CRC  Ȯ ÷
        bool bDataFail; //   Ȯ ÷
        AnsiString asLogMessage; // α ޽
        AnsiString Status; //  üũ
        Response RP; // ú  ü
        AnsiString DNSAddress; // DDNS  IP ּ
        bool DNSConnect; // TCP/IP   
        bool bDisConnect; // TCP/IP   
        bool bMsg; // α ޽  ÷
        BYTE FailData; // ú   
        int ProgramType; //  ÷ 
        int MessageCount; // Ϲݹ ִ 
        int ProtocolTabKind; // /Ϲ/Ư  
        int ProtocolPageNo2; // Ϲݹ  
        int ProtocolBlockNo; // ޹  
        int ProtocolBlockNo2; // Ϲݹ  
        int LogFileCnt; // α   īƮ
        AnsiString OldLogDate; // α   ¥
        sProtocolData ProtocolData; // /Ϲ   ü
        WideString EffectType[EffectTypeCount]; // ȿ 
        WideString DirType[DirTypeCount]; // ȿ 
        AnsiString SpeedValue[19]; // ӵ
        AnsiString DelayValue[20]; // ð
        void __fastcall SendData(BYTE ComKind, BYTE Add, BYTE *Data, DWORD DataLen, int Number, OPCode OPC); //    Լ
        void __fastcall ReadParsing(BYTE ComKind, char Add, BYTE *ParsingData, int ParsingSize); // Ľ Լ
        int __fastcall ReturnDay(TDateTime Time); //    Լ
        bool __fastcall CurrenTimeSync(); // PC ð 
        void __fastcall ButtonEnabled(bool bEnabled); // ư Ȱȭ Լ
public:		// User declarations
        TFormMessage *formMessage; // ޽ Լ 
        TIdSocketHandle *SH; // UDP  
        bool bFlagCrcPacket; // CRC  ÷
        AnsiString    PortUse1; // COM Ʈ 
        eBaudRate     BaudRateUse1; // COM BaudRate 
        int Controler1; //  巹 
        AnsiString    IPAddress; // TCP/IP 
        int IPPort; // TCP/IP Ʈ 
        AnsiString    UDPIPAddress; // UDP IP 
        int DSPPort; // UDP  Ʈ 
        int SRCPort; // UDP DabitChe Ʈ 
        BYTE ComKind; //   
        bool bStopSend; //   ÷
        Language LangFile; //   ü
        AnsiString BasePath; //  
        AnsiString DestSysPath; // System 
        AnsiString DestLogPath; // Log 
        int ModuleWidth; //   ũ
        int ModuleHeight; //   ũ
        AnsiString asUDPIPAddress; // ۵ UDP IP
        void __fastcall RoadIniFile(); //   ini Ͽ ҷ Լ
        void __fastcall SaveIniFile(); // ini   Լ
        void __fastcall RoadLangFile(AnsiString aslang); //  ҷ Լ
        void __fastcall InputLang(); //   Լ
        bool __fastcall ModuleData(BYTE ComKind, BYTE Addr, BYTE *Data, DWORD DataLen, int Number, OPCode OPC, bool bMessage); //   ú  ޴ Ǵ Լ
        bool __fastcall ComPortSet(BYTE ComKind, AnsiString PortUse, BYTE BaudRateUse, BYTE DTR, BYTE RTS, AnsiString IPAddress, int IPPort, bool bMessage); //   Լ
        bool __fastcall ComClose(BYTE ComKind); //  ݴ Լ
        void __fastcall NoneDelayCount(int Cnt); //  Լ
        void __fastcall LANDelayCount(int Cnt); //   Լ
        AnsiString __fastcall GetDNS(); // PC DNS о Լ
        unsigned short int __fastcall Calc_crc(unsigned char *buf, int numbytes); // CRC Լ
        AnsiString __fastcall Byte2HexConvert(BYTE Value); // Byte   String Hex ȯ Լ
        BYTE __fastcall Hex2ByteConvert(AnsiString Value); // String Hex  Byte  ȯ Լ
        int __fastcall Message(WideString Mes, WideString wsYes, WideString wsNo, WideString wsCancel, int Width, int Height, int btnCnt, TColor FontColor); // ޽ Լ
        void __fastcall AddLog(AnsiString Msg, TColor Color); // α ǥ   Լ
        void __fastcall DeleteOldLogFile(AnsiString SitePath); //  α  Լ
        int __fastcall FindItemIndex(AnsiString Data, int Col); // ȿ, ε  Լ
        BYTE __fastcall InputSchEffect(TGEffectType eEff, TGEffectDirection dDirect); //  ȿ  Լ
        BYTE __fastcall SetDelayTime(int DelayTime); // ̰  Լ
        AnsiString __fastcall GetDay(int iDay); //   String  Լ
        __fastcall TFormMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TFormMain *FormMain;
//---------------------------------------------------------------------------
#endif
